<?php
/**
 * VW Shopping Mall functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package VW Shopping Mall
 */

if ( ! defined( 'VW_SHOPPING_MALL_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'VW_SHOPPING_MALL_VERSION', wp_get_theme()->get( 'Version' ) );
}

if ( ! function_exists( 'vw_shopping_mall_setup' ) ) :
	/**
	 * Sets up theme defaults and registers support for various WordPress features.
	 *
	 * Note that this function is hooked into the after_setup_theme hook, which
	 * runs before the init hook. The init hook is too late for some features, such
	 * as indicating support for post thumbnails.
	 */
	function vw_shopping_mall_setup() {

		// Add default posts and comments RSS feed links to head.
		add_theme_support( 'automatic-feed-links' );

		add_theme_support( 'align-wide' );

		add_theme_support( 'woocommerce' );

		// Add support for block styles.
		add_theme_support( 'wp-block-styles' );

		// Enqueue editor styles.
		add_editor_style( 'style.css' );

		// Add support for core custom logo.
		add_theme_support(
			'custom-logo',
			array(
				'height'      => 192,
				'width'       => 192,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		// Enqueue editor styles.
		// add_editor_style( 'style.css' );

		// Experimental support for adding blocks inside nav menus
		add_theme_support( 'block-nav-menus' );

		// Add support for experimental link color control.
		add_theme_support( 'experimental-link-color' );
	}
endif;
add_action( 'after_setup_theme', 'vw_shopping_mall_setup' );

/**
 * Enqueue scripts and styles.
 */
function vw_shopping_mall_scripts() {
	wp_enqueue_style('vw-shopping-mall-style', get_stylesheet_uri(), array() );
	wp_enqueue_script( 'jquery-wow', esc_url(get_template_directory_uri()) . '/js/wow.js', array('jquery') );
	wp_enqueue_style( 'animate-css', esc_url(get_template_directory_uri()).'/css/animate.css' );
	wp_enqueue_style('swiper-css', esc_url(get_template_directory_uri())."/css/swiper-bundle.css");
	wp_enqueue_script('swiper-js', esc_url(get_template_directory_uri()). '/js/swiper-bundle.js', array('jquery'));
	wp_enqueue_script( 'vw-shopping-mall-custom-scripts', get_template_directory_uri() . '/js/custom.js', array('jquery'),'' ,true );
	wp_style_add_data( 'vw-shopping-mall-style', 'rtl', 'replace' );
}
add_action( 'wp_enqueue_scripts', 'vw_shopping_mall_scripts' );

/**
 * Enqueue block editor style
 */
function vw_shopping_mall_block_editor_styles() {
	wp_enqueue_style( 'vw-shopping-mall-block-patterns-style-editor', get_theme_file_uri( '/css/block-editor.css' ), false, '1.0', 'all' );
}
add_action( 'enqueue_block_editor_assets', 'vw_shopping_mall_block_editor_styles' );

function vw_shopping_mall_init_setup() {
	define('VW_SHOPPING_MALL_BUY_NOW',__('https://www.vwthemes.com/products/shopping-mall-wordpress-theme','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_SUPPORT',__('https://wordpress.org/support/theme/vw-shopping-mall/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_REVIEW',__('https://wordpress.org/support/theme/vw-shopping-mall/reviews/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_LIVE_DEMO',__('https://www.vwthemes.net/vw-shopping-mall-pro/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_PRO_DOC',__('https://preview.vwthemesdemo.com/docs/vw-shopping-mall-pro/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_FREE_DOC',__('https://preview.vwthemesdemo.com/docs/free-vw-shopping-mall/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_FAQ',__('https://www.vwthemes.com/faqs/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_CHILD_THEME',__('https://developer.wordpress.org/themes/advanced-topics/child-themes/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_CONTACT',__('https://www.vwthemes.com/contact/','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_THEME_BUNDLE_BUY_NOW',__('https://www.vwthemes.com/products/wp-theme-bundle','vw-shopping-mall'));
	define('VW_SHOPPING_MALL_THEME_BUNDLE_DOC',__('https://preview.vwthemesdemo.com/docs/theme-bundle/','vw-shopping-mall'));

	// Add block patterns
	require get_template_directory() . '/inc/block-patterns.php';

	/**
	 * Section Pro
	 */
	require get_template_directory() . '/inc/section-pro/customizer.php';

	/**
	 * notice
	 */
	require get_template_directory() . '/inc/core/activation-notice.php';

	/**
	 * TGM
	 */
	require_once get_template_directory() . '/inc/tgm/plugin-activation.php';

	/**
	 * Load core file.
	 */
	require_once get_template_directory() . '/inc/core/theme-info.php';
	require_once get_template_directory() . '/inc/core/template-functions.php';
}
add_action( 'after_setup_theme', 'vw_shopping_mall_init_setup' );	

/* Enqueue admin-notice-script js */
add_action('admin_enqueue_scripts', function ($hook) {
    //if ($hook !== 'appearance_page_vw-shopping-mall') return;

    wp_enqueue_script('admin-notice-script', get_template_directory_uri() . '/inc/core/js/admin-notice-script.js', ['jquery'], null, true);
    wp_localize_script('admin-notice-script', 'pluginInstallerData', [
        'ajaxurl'     => admin_url('admin-ajax.php'),
        'nonce'       => wp_create_nonce('install_plugin_nonce'), // Match this with PHP nonce check
        'redirectUrl' => admin_url('admin.php?page=vw-shopping-mall-info'),
    ]);
});

add_action('wp_ajax_check_plugin_activation', function () {
    if (!isset($_POST['plugin']) || empty($_POST['plugin'])) {
        wp_send_json_error(['message' => 'Missing plugin identifier']);
    }

    include_once ABSPATH . 'wp-admin/includes/plugin.php';

    // Map plugin identifiers to their main files
    $vw_shopping_mall_plugin_map = [
        'video_popup'          => 'wpzoom-video-popup-block/wpzoom-video-popup-block.php',
        'ibtana'               => 'ibtana-visual-editor/plugin.php',
    ];

    $vw_shopping_mall_requested_plugin = sanitize_text_field($_POST['plugin']);

    if (!isset($vw_shopping_mall_plugin_map[$vw_shopping_mall_requested_plugin])) {
        wp_send_json_error(['message' => 'Invalid plugin']);
    }

    $vw_shopping_mall_plugin_file = $vw_shopping_mall_plugin_map[$vw_shopping_mall_requested_plugin];
    $vw_shopping_mall_is_active   = is_plugin_active($vw_shopping_mall_plugin_file);

    wp_send_json_success(['active' => $vw_shopping_mall_is_active]);
});

function vw_shopping_mall_dismissed_notice() {
	update_option( 'vw_shopping_mall_activation_notice', true );
    wp_die();
}
add_action( 'wp_ajax_vw_shopping_mall_dismissed_notice', 'vw_shopping_mall_dismissed_notice' );